/*================================================================================================================*/
// ************************************** THESE ARE THE MAP INFORMATIONS: *************************************** //
/*================================================================================================================*/
// ANALYZED BY DANY:
// DECEMBER 2006:
// GREAT PLAINS LARGE BY ENSEMBLE:
// JUNE 2003:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: *********************************** //
/*================================================================================================================*/
      int subCiv0=-1;
      int subCiv1=-1;
      int subCiv2=-1;
      int subCiv3=-1;
      int subCiv4=-1;
      int subCiv5=-1;
/*----------------------------------------------------------------------------------------------------------------*/	  
      int whichNative=rmRandInt(1,4);
/*----------------------------------------------------------------------------------------------------------------*/	  
	  if ( whichNative == 1)
{
	  if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Cree");
      if (subCiv0 >= 0)
         rmSetSubCiv(0, "Cree");

		subCiv1=rmGetCivID("Cree");
      if (subCiv1 >= 0)
         rmSetSubCiv(1, "Cree"); 

		subCiv2=rmGetCivID("Cree");
      if (subCiv2 >= 0)
         rmSetSubCiv(2, "Cree");

		subCiv3=rmGetCivID("Cree");
      if (subCiv3 >= 0)
         rmSetSubCiv(3, "Cree");
		 
		 subCiv4=rmGetCivID("Cree");
      if (subCiv4 >= 0)
         rmSetSubCiv(4, "Cree");

		subCiv5=rmGetCivID("Cree");
      if (subCiv5 >= 0)
         rmSetSubCiv(5, "Cree");
   }  
	  
}	   
/*----------------------------------------------------------------------------------------------------------------*/        
        else if ( whichNative == 2)
{    
		if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Iroquois");
      if (subCiv0 >= 0)
         rmSetSubCiv(0, "Iroquois");

		subCiv1=rmGetCivID("Iroquois");
      if (subCiv1 >= 0)
         rmSetSubCiv(1, "Iroquois"); 

		subCiv2=rmGetCivID("Iroquois");
      if (subCiv2 >= 0)
         rmSetSubCiv(2, "Iroquois");

		subCiv3=rmGetCivID("Iroquois");
      if (subCiv3 >= 0)
         rmSetSubCiv(3, "Iroquois");
		 
		 subCiv4=rmGetCivID("Iroquois");
      if (subCiv4 >= 0)
         rmSetSubCiv(4, "Iroquois");

		subCiv5=rmGetCivID("Iroquois");
      if (subCiv5 >= 0)
         rmSetSubCiv(5, "Iroquois");
   }
}
/*----------------------------------------------------------------------------------------------------------------*/
        else if ( whichNative == 3)
{    
		if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Lakota");
      if (subCiv0 >= 0)
         rmSetSubCiv(0, "Lakota");

		subCiv1=rmGetCivID("Lakota");
      if (subCiv1 >= 0)
         rmSetSubCiv(1, "Lakota"); 

		subCiv2=rmGetCivID("Lakota");
      if (subCiv2 >= 0)
         rmSetSubCiv(2, "Lakota");

		subCiv3=rmGetCivID("Lakota");
      if (subCiv3 >= 0)
         rmSetSubCiv(3, "Lakota");
		 
		 subCiv4=rmGetCivID("Lakota");
      if (subCiv4 >= 0)
         rmSetSubCiv(4, "Lakota");

		subCiv5=rmGetCivID("Lakota");
      if (subCiv5 >= 0)
         rmSetSubCiv(5, "Lakota");
   }
}
/*----------------------------------------------------------------------------------------------------------------*/	 
	else
{    
		if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Cherokee");
      if (subCiv0 >= 0)
         rmSetSubCiv(0, "Cherokee");

		subCiv1=rmGetCivID("Cherokee");
      if (subCiv1 >= 0)
         rmSetSubCiv(1, "Cherokee"); 

		subCiv2=rmGetCivID("Cherokee");
      if (subCiv2 >= 0)
         rmSetSubCiv(2, "Cherokee");

		subCiv3=rmGetCivID("Cherokee");
      if (subCiv3 >= 0)
         rmSetSubCiv(3, "Cherokee");
		 
		 subCiv4=rmGetCivID("Cherokee");
      if (subCiv4 >= 0)
         rmSetSubCiv(4, "Cherokee");

		subCiv5=rmGetCivID("Cherokee");
      if (subCiv5 >= 0)
         rmSetSubCiv(5, "Cherokee");
   }
}
/*================================================================================================================*/
// ************* CHOOSE WHICH VARIATION TO USE:  1=SOUTHEAST TRADE ROUTE, 2=NORTHWEST TRADE ROUTE: ************** //
/*================================================================================================================*/
	int whichMap=rmRandInt(1,3);
	// int whichMap=2;
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
	  int playerTiles=21000;
      
	  if (cNumberNonGaiaPlayers >4)
		  playerTiles = 19000;
      if (cNumberNonGaiaPlayers >6)
          playerTiles = 16000;
	  
	  int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	  rmEchoInfo("Map size="+size+"m x "+size+"m");
	  rmSetMapSize(size, size);
/*================================================================================================================*/	
// ***************************************** PICKS THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/
	  // PICKS A DEFAULT WATER HEIGHT:
	  rmSetSeaLevel(0.0);

      // SET MAP ELEVATION PARAMETERS:
	  rmSetMapElevationParameters(cElevTurbulence, 0.02, 7, 0.5, 8.0);
	  
	  // SET BASE TERRAIN MIX:
	  rmSetBaseTerrainMix("great plains drygrass");
	  
	  // TERRAIN INITIALIZE:
	  rmTerrainInitialize("yukon\ground1_yuk", 5);
	  
	  // SET THE LIGHTING:
	  rmSetLightingSet("great plains");
	  
	  // SET THE MAP TYPE:
	  rmSetMapType("greatPlains");
	  rmSetMapType("land");
	  rmSetMapType("grass");
	  
	  // SET WORLD CIRCLE CONSTRAINT:
	  rmSetWorldCircleConstraint(true);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
	  int classPlayer=rmDefineClass("player");
	  rmDefineClass("classPatch");
	  rmDefineClass("starting settlement");
	  rmDefineClass("startingUnit");
	  rmDefineClass("classForest");
	  rmDefineClass("importantItem");
	  rmDefineClass("secrets");
	  rmDefineClass("natives");	
	  rmDefineClass("classHillArea");
	  rmDefineClass("socketClass");
	  rmDefineClass("nuggets");
	  int pondClass=rmDefineClass("pond");
/*================================================================================================================*/
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
      // MAP EDGE CONSTRAINTS:
      //int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
      int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(15), rmZTilesToFraction(15), 1.0-rmXTilesToFraction(15), 1.0-rmZTilesToFraction(15), 0.01);
      	  
      // PLAYER CONSTRAINTS:
      int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 10.0);
      int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
      int nuggetPlayerConstraint=rmCreateClassDistanceConstraint("nuggets stay away from players a lot", classPlayer, 40.0);

      // RESOURCE AVOIDANCE:
      int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 35.0);
      int coinForestConstraint=rmCreateClassDistanceConstraint("coin vs. forest", rmClassID("classForest"), 15.0);
      
	  // BISON AVOIDANCE:
	  int avoidBison=rmCreateTypeDistanceConstraint("bison avoids food", "Bison", 15.0);
	  int bisonAvoidBison=rmCreateTypeDistanceConstraint("bison avoids bison", "Bison", 35.0);
	  
	  // COW AVOIDANCE:
	  int avoidCow=rmCreateTypeDistanceConstraint("stuffs avoids cow", "cow", 15.0);
	  int cowAvoidCow=rmCreateTypeDistanceConstraint("cow avoids cow", "Cow", 60.0);
      	  
	  // PRONGHORN AVOIDANCE:
	  int avoidPronghorn=rmCreateTypeDistanceConstraint("pronghorn avoids food", "pronghorn", 15.0);
	  	  
	  int avoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 15.0);
	  int avoidStartingCoin=rmCreateTypeDistanceConstraint("starting coin avoids coin", "gold", 12.0);
      
	  // NUGGET AVOIDANCE:
	  int avoidNugget=rmCreateTypeDistanceConstraint("stuffs avoid nugget", "AbstractNugget", 15.0);
	  int nuggetAvoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 45.0);
      int avoidNuggetSmall=rmCreateTypeDistanceConstraint("avoid nuggets by a little", "AbstractNugget", 10.0);
	  
	  // Nature avoidance
      int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 12.0);
      int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
   	  	  
	  // FRUITS AVOIDANCE:
	  int avoidFruits=rmCreateTypeDistanceConstraint("stuffs avoids berries", "BerryBush", 4.0);

	  int avoidFastCoin=-1;
	  if (cNumberNonGaiaPlayers >6)
	  {
		  avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.12));
	  }
	  else if (cNumberNonGaiaPlayers >4)
	  {
		  avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.14));
	  }
	  else
	  {
		  avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.16));
	  }

      // AVOID IMPASSABLE LAND:
      int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
      int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
      int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);

      // UNIT AVOIDANCE: - FOR THINGS THAT AREN'T IN THE STARTING RESOURCES:
      int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
      int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 8.0);

      // POND AVOIDANCE:
	  int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 15.0);
	  int avoidPond=rmCreateClassDistanceConstraint("stuffs avoid ponds", rmClassID("pond"), 15.0);
	  int avoidClosePond=rmCreateClassDistanceConstraint("close stuffs avoid ponds", rmClassID("pond"), 5.0);
	  	  
	  // TREES AVOIDANCE:
	  int avoidArbuste=rmCreateTypeDistanceConstraint("stuffs avoids trees", "TreeGreatPlains", 4.0);
	  int arbusteAvoidArbuste=rmCreateTypeDistanceConstraint("trees avoids trees", "TreeGreatPlains", 8.0);
	  
	  // DECORATION AVOIDANCE:
      int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

      // VP AVOIDANCE:
      int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
      int avoidTradeRouteSmall = rmCreateTradeRouteDistanceConstraint("trade route small", 4.0);
      // int avoidTradeRoutePlayer = rmCreateTradeRouteDistanceConstraint("trade route player", 30.0);
      int avoidImportantItem=rmCreateClassDistanceConstraint("important stuff avoids each other", rmClassID("importantItem"), 15.0);

	  int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 8.0);
	  int avoidSocketMore=rmCreateClassDistanceConstraint("bigger socket avoidance", rmClassID("socketClass"), 15.0);

      // CONSTRAINT TO AVOID WATER:
      int avoidWater10 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 10.0);
      int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 20.0);
      int avoidWater40 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 40.0);

	  // AVOID THE HILLY AREAS:
	  int avoidHills = rmCreateClassDistanceConstraint("avoid Hills", rmClassID("classHillArea"), 5.0);
	  
	  // NATIVES AVOIDANCES:
	  int avoidNatives = rmCreateClassDistanceConstraint("stuffs avoid Natives", rmClassID("natives"), 12.0);
	  int avoidCloseNatives = rmCreateClassDistanceConstraint("close stuffs avoid Natives", rmClassID("natives"), 8.0);
	  int avoidNativesNuggets = rmCreateClassDistanceConstraint("nuggets avoid Natives", rmClassID("natives"), 10.0);

	  // CIRCLE CONSTRAINT:
	  int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE TRADE ROUTE: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*================================================================================================================*/      
// ********************************************* DEFINE THE AREAS: ********************************************** //
// ************************************* SET UP PLAYER STARTING LOCATIONS: ************************************** //
/*================================================================================================================*/
   if ( whichMap == 1 )
   {
	   rmSetPlacementSection(0.7, 0.3); // 0.5
   }
   else
   {
	   rmSetPlacementSection(0.2, 0.8); // 0.5	   	
   }
   rmSetTeamSpacingModifier(0.7);
   rmPlacePlayersCircular(0.38, 0.38, 0);
/*================================================================================================================*/
// ******************************************** SET UP PLAYER AREAS: ******************************************** //
/*================================================================================================================*/
   float playerFraction=rmAreaTilesToFraction(100);
   for(i=1; <cNumberPlayers)
   {
      // Create the area.
      int id=rmCreateArea("Player"+i);
      // Assign to the player.
      rmSetPlayerArea(i, id);
      // Set the size.
      rmSetAreaSize(id, playerFraction, playerFraction);
      rmAddAreaToClass(id, classPlayer);
      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, playerEdgeConstraint); 
	  rmAddAreaConstraint(id, avoidTradeRoute); 
      rmSetAreaLocPlayer(id, i);
      rmSetAreaWarnFailure(id, false);
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ****************************************** DEFINE THE HILLS AREAS: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// PLACEMENT ORDER OF NON-TRADE ROUTE STUFF:
// NATIVES -> SECRETS -> NUGGETS -> SMALL PONDS (WHEE)
/*================================================================================================================*/
// ******************** DEFINE THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ********************* //
/*================================================================================================================*/
      //DEFINE STARTING UNITS:
	  int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	  rmSetObjectDefMinDistance(startingUnits, 7.0);
	  rmSetObjectDefMaxDistance(startingUnits, 12.0);

	  // DEFINE THE STARTING TCID:
	  int startingTCID = rmCreateObjectDef("startingTC");
	  if ( rmGetNomadStart())
	  {
		  rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	  }
	  else
	  {
		  rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	  }
	  rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	  rmSetObjectDefMinDistance(startingTCID, 0.0);
	  rmSetObjectDefMaxDistance(startingTCID, 9.0);
	  rmAddObjectDefConstraint(startingTCID, avoidTradeRouteSmall);

	  // rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);
/*================================================================================================================*/
	  // DEFINE THE STARTING TREE:
	  int StartAreaTreeID=rmCreateObjectDef("starting trees");
	  rmAddObjectDefItem(StartAreaTreeID, "TreeGreatPlains", 1, 0.0);
	  rmSetObjectDefMinDistance(StartAreaTreeID, 12.0);
	  rmSetObjectDefMaxDistance(StartAreaTreeID, 18.0);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	  // DEFINE THE STARTING BISON:
	  int StartBisonID=rmCreateObjectDef("starting bison");
	  rmAddObjectDefItem(StartBisonID, "Bison", 4, 4.0);
	  rmSetObjectDefMinDistance(StartBisonID, 10.0);
	  rmSetObjectDefMaxDistance(StartBisonID, 12.0);
	  rmSetObjectDefCreateHerd(StartBisonID, true);
	  rmAddObjectDefConstraint(StartBisonID, avoidStartingUnitsSmall);

	  // DEFINE THE STARTING FRUITS:
	  int StartberriesID=rmCreateObjectDef("starting berries");
	  rmAddObjectDefItem(StartberriesID, "BerryBush", 4, 6.0);
	  rmSetObjectDefMinDistance(StartberriesID, 10.0);
	  rmSetObjectDefMaxDistance(StartberriesID, 12.0);
	  rmSetObjectDefCreateHerd(StartberriesID, true);
	  rmAddObjectDefConstraint(StartberriesID, avoidStartingUnitsSmall);
	  
	  // DEFINE THE PLAYER NUGGET:
	  int playerNuggetID=rmCreateObjectDef("player nugget");
	  rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	  rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
	  rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
      rmSetObjectDefMinDistance(playerNuggetID, 28.0);
      rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	  rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	  rmAddObjectDefConstraint(playerNuggetID, avoidNativesNuggets);
	  rmAddObjectDefConstraint(playerNuggetID, avoidTradeRouteSmall);
	  rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	  // rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ********************** PLACE THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ******************** //
/*================================================================================================================*/	
	    int silverType = -1;
	    int playerGoldID = -1;

 	    for(i=1; <cNumberPlayers)
	{
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
/*----------------------------------------------------------------------------------------------------------------*/
		// THIS WAS REMOVED BY ENSEMBLE:
		// vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
		// rmSetHomeCityGatherPoint(i, closestPoint);
/*================================================================================================================*/
// ************ EVERYONE GETS TWO ORE OBJECTSDEFS, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY: *********** //
/*================================================================================================================*/
		// DEFINE THE SILVER MINES:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddObjectDefToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		
		// PLACE THE TWO GOLD MINES:
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE BISON:
		rmPlaceObjectDefAtLoc(StartBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE BERRIES:
		rmPlaceObjectDefAtLoc(StartberriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE NUGGET:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE NATIVE AMERICANS: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
         if ( whichNative == 1 )
{        
		 if (subCiv0 == rmGetCivID("cree"))
	{  
		int cree1VillageID = -1;
		cree1VillageID = rmCreateGrouping("cree village 1", "native cree village 1");
		rmSetGroupingMinDistance(cree1VillageID, 0.0);
		rmSetGroupingMaxDistance(cree1VillageID, 0.0);
		//rmSetGroupingMaxDistance(cree1VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(cree1VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cree1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree1VillageID, avoidNatives);
		//rmAddGroupingConstraint(cree1VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(cree1VillageID, 0, 0.7, 0.8);
	} 

	    if (subCiv1 == rmGetCivID("cree"))
	{  
		int cree2VillageID = -1;
		cree2VillageID = rmCreateGrouping("cree village 2", "native cree village 1");
		rmSetGroupingMinDistance(cree2VillageID, 0.0);
		rmSetGroupingMaxDistance(cree2VillageID, 0.0);
		//rmSetGroupingMaxDistance(cree2VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(cree2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cree2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree2VillageID, avoidNatives);
		//rmAddGroupingConstraint(cree2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(cree2VillageID, 0, 0.3, 0.8);
	} 

	    if (subCiv2 == rmGetCivID("cree"))
	{  
		int cree3VillageID = -1;
		cree3VillageID = rmCreateGrouping("cree village 3", "native cree village 1");
		rmSetGroupingMinDistance(cree3VillageID, 0.0);
		rmSetGroupingMaxDistance(cree3VillageID, 0.0);
		//rmSetGroupingMaxDistance(cree3VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(cree3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cree3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree3VillageID, avoidNatives);
		//rmAddGroupingConstraint(cree3VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(cree3VillageID, 0, 0.3, 0.5);
	}

	    if (subCiv3 == rmGetCivID("cree"))
	{  
		int cree4VillageID = -1;
		cree4VillageID = rmCreateGrouping("cree village 4", "native cree village 1");
		rmSetGroupingMinDistance(cree4VillageID, 0.0);
		rmSetGroupingMaxDistance(cree4VillageID, 0.0);
		//rmSetGroupingMaxDistance(cree4VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(cree4VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cree4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree4VillageID, avoidNatives);
		//rmAddGroupingConstraint(cree4VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(cree4VillageID, 0, 0.7, 0.5);
	} 
	
	    if (subCiv4 == rmGetCivID("cree"))
	{  
		int cree5VillageID = -1;
		cree5VillageID = rmCreateGrouping("cree village 5", "native cree village 1");
		rmSetGroupingMinDistance(cree5VillageID, 0.0);
		rmSetGroupingMaxDistance(cree5VillageID, 0.0);
		//rmSetGroupingMaxDistance(cree5VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(cree5VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cree5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree5VillageID, avoidNatives);
		//rmAddGroupingConstraint(cree5VillageID, avoidSocket);
		rmPlaceGroupingAtLoc(cree5VillageID, 0, 0.3, 0.2);
	} 

	    if (subCiv5 == rmGetCivID("cree"))
	{  
		int cree6VillageID = -1;
		cree6VillageID = rmCreateGrouping("cree village 6", "native cree village 1");
		rmSetGroupingMinDistance(cree6VillageID, 0.0);
		rmSetGroupingMaxDistance(cree6VillageID, 0.0);
		//rmSetGroupingMaxDistance(cree6VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(cree6VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cree6VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree6VillageID, avoidNatives);
		//rmAddGroupingConstraint(cree6VillageID, avoidSocket);
		rmPlaceGroupingAtLoc(cree6VillageID, 0, 0.7, 0.2);
	} 
}
	
        else if ( whichNative == 2 )

{
        if (subCiv0 == rmGetCivID("iroquois"))
	{  
		int iroquois1VillageID = -1;
		iroquois1VillageID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois1VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois1VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois1VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois1VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois1VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois1VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.7, 0.8);
	} 

	    if (subCiv1 == rmGetCivID("iroquois"))
	{  
		int iroquois2VillageID = -1;
		iroquois2VillageID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois2VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois2VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois2VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois2VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.3, 0.8);
	} 

	    if (subCiv2 == rmGetCivID("iroquois"))
	{  
		int iroquois3VillageID = -1;
		iroquois3VillageID = rmCreateGrouping("iroquois village 3", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois3VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois3VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois3VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois3VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois3VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois3VillageID, 0, 0.3, 0.5);
	}

	    if (subCiv3 == rmGetCivID("iroquois"))
	{  
		int iroquois4VillageID = -1;
		iroquois4VillageID = rmCreateGrouping("iroquois village 4", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois4VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois4VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois4VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois4VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois4VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois4VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois4VillageID, 0, 0.7, 0.5);
	} 
	
	    if (subCiv4 == rmGetCivID("iroquois"))
	{  
		int iroquois5VillageID = -1;
		iroquois5VillageID = rmCreateGrouping("iroquois village 5", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois5VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois5VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois5VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois5VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois5VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois5VillageID, avoidSocket);
		rmPlaceGroupingAtLoc(iroquois5VillageID, 0, 0.3, 0.2);
	} 

	    if (subCiv5 == rmGetCivID("iroquois"))
	{  
		int iroquois6VillageID = -1;
		iroquois6VillageID = rmCreateGrouping("iroquois village 6", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois6VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois6VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois6VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois6VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois6VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois6VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois6VillageID, avoidSocket);
		rmPlaceGroupingAtLoc(iroquois6VillageID, 0, 0.7, 0.2);
	} 
}

        else if ( whichNative == 3 )

{
        if (subCiv0 == rmGetCivID("lakota"))
	{  
		int lakotaVillageID = -1;
		lakotaVillageID = rmCreateGrouping("lakota village 1", "native lakota village 1");
		rmSetGroupingMinDistance(lakotaVillageID, 0.0);
		rmSetGroupingMaxDistance(lakotaVillageID, 0.0);
		//rmAddGroupingConstraint(lakotaVillageID, avoidImpassableLand);
		rmAddGroupingToClass(lakotaVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(lakotaVillageID, avoidNatives);
		//rmAddGroupingConstraint(lakotaVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(lakotaVillageID, 0, 0.7, 0.8);
	} 
	
	    if (subCiv1 == rmGetCivID("lakota"))
	{  
		int lakota2VillageID = -1;
		lakota2VillageID = rmCreateGrouping("lakota village 2", "native lakota village 1");
		rmSetGroupingMinDistance(lakota2VillageID, 0.0);
		rmSetGroupingMaxDistance(lakota2VillageID, 0.0);
		//rmAddGroupingConstraint(lakota2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(lakota2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(lakota2VillageID, avoidNatives);
		//rmAddGroupingConstraint(lakota2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(lakota2VillageID, 0, 0.3, 0.8);
	} 
	
	    if (subCiv2 == rmGetCivID("lakota"))
	{  
		int lakota3VillageID = -1;
		lakota3VillageID = rmCreateGrouping("lakota village 3", "native lakota village 1");
		rmSetGroupingMinDistance(lakota3VillageID, 0.0);
		rmSetGroupingMaxDistance(lakota3VillageID, 0.0);
		//rmAddGroupingConstraint(lakota3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(lakota3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(lakota3VillageID, avoidNatives);
		//rmAddGroupingConstraint(lakota3VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(lakota3VillageID, 0, 0.3, 0.5);
	} 
	
	    if (subCiv3 == rmGetCivID("lakota"))
	{  
		int lakota4VillageID = -1;
		lakota4VillageID = rmCreateGrouping("lakota village 4", "native lakota village 1");
		rmSetGroupingMinDistance(lakota4VillageID, 0.0);
		rmSetGroupingMaxDistance(lakota4VillageID, 0.0);
		//rmAddGroupingConstraint(lakota4VillageID, avoidImpassableLand);
		rmAddGroupingToClass(lakota4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(lakota4VillageID, avoidNatives);
		//rmAddGroupingConstraint(lakota4VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(lakota4VillageID, 0, 0.7, 0.5);
	} 
	
	    if (subCiv4 == rmGetCivID("lakota"))
	{  
		int lakota5VillageID = -1;
		lakota5VillageID = rmCreateGrouping("lakota village 5", "native lakota village 1");
		rmSetGroupingMinDistance(lakota5VillageID, 0.0);
		rmSetGroupingMaxDistance(lakota5VillageID, 0.0);
		//rmAddGroupingConstraint(lakota5VillageID, avoidImpassableLand);
		rmAddGroupingToClass(lakota5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(lakota5VillageID, avoidNatives);
		//rmAddGroupingConstraint(lakota5VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(lakota5VillageID, 0, 0.3, 0.2);
	} 
	
	    if (subCiv5 == rmGetCivID("lakota"))
	{  
		int lakota6VillageID = -1;
		lakota6VillageID = rmCreateGrouping("lakota village 6", "native lakota village 1");
		rmSetGroupingMinDistance(lakota6VillageID, 0.0);
		rmSetGroupingMaxDistance(lakota6VillageID, 0.0);
		//rmAddGroupingConstraint(lakota6VillageID, avoidImpassableLand);
		rmAddGroupingToClass(lakota6VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(lakota6VillageID, avoidNatives);
		//rmAddGroupingConstraint(lakota6VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(lakota6VillageID, 0, 0.7, 0.2);
	} 
}

else

{
        if (subCiv0 == rmGetCivID("cherokee"))
	{  
		int cherokee1VillageID = -1;
		cherokee1VillageID = rmCreateGrouping("cherokee village 1", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee1VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee1VillageID, 0.0);
		//rmSetGroupingMaxDistance(cherokee1VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(cherokee1VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokee1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee1VillageID, avoidNatives);
		//rmAddGroupingConstraint(cherokee1VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(cherokee1VillageID, 0, 0.7, 0.8);
	} 

	    if (subCiv1 == rmGetCivID("cherokee"))
	{  
		int cherokee2VillageID = -1;
		cherokee2VillageID = rmCreateGrouping("cherokee village 2", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee2VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee2VillageID, 0.0);
		//rmSetGroupingMaxDistance(cherokee2VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(cherokee2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokee2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee2VillageID, avoidNatives);
		//rmAddGroupingConstraint(cherokee2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(cherokee2VillageID, 0, 0.3, 0.8);
	} 

	    if (subCiv2 == rmGetCivID("cherokee"))
	{  
		int cherokee3VillageID = -1;
		cherokee3VillageID = rmCreateGrouping("cherokee village 3", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee3VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee3VillageID, 0.0);
		//rmSetGroupingMaxDistance(cherokee3VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(cherokee3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokee3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee3VillageID, avoidNatives);
		//rmAddGroupingConstraint(cherokee3VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(cherokee3VillageID, 0, 0.3, 0.5);
	}

	    if (subCiv3 == rmGetCivID("cherokee"))
	{  
		int cherokee4VillageID = -1;
		cherokee4VillageID = rmCreateGrouping("cherokee village 4", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee4VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee4VillageID, 0.0);
		//rmSetGroupingMaxDistance(cherokee4VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(cherokee4VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokee4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee4VillageID, avoidNatives);
		//rmAddGroupingConstraint(cherokee4VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(cherokee4VillageID, 0, 0.7, 0.5);
	} 
	
	    if (subCiv4 == rmGetCivID("cherokee"))
	{  
		int cherokee5VillageID = -1;
		cherokee5VillageID = rmCreateGrouping("cherokee village 5", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee5VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee5VillageID, 0.0);
		//rmSetGroupingMaxDistance(cherokee5VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(cherokee5VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokee5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee5VillageID, avoidNatives);
		//rmAddGroupingConstraint(cherokee5VillageID, avoidSocket);
		rmPlaceGroupingAtLoc(cherokee5VillageID, 0, 0.3, 0.2);
	} 

	    if (subCiv5 == rmGetCivID("cherokee"))
	{  
		int cherokee6VillageID = -1;
		cherokee6VillageID = rmCreateGrouping("cherokee village 6", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee6VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee6VillageID, 0.0);
		//rmSetGroupingMaxDistance(cherokee6VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(cherokee6VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokee6VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee6VillageID, avoidNatives);
		//rmAddGroupingConstraint(cherokee6VillageID, avoidSocket);
		rmPlaceGroupingAtLoc(cherokee6VillageID, 0, 0.7, 0.2);
	} 
}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE FIXED FRUITS: ************************************** //
/*================================================================================================================*/
      int berries1ID=rmCreateObjectDef("The Berries 1");
      rmAddObjectDefItem(berries1ID, "BerryBush", rmRandInt(3,5), 5.0);
      rmSetObjectDefMinDistance(berries1ID, 0.0);
      rmSetObjectDefMaxDistance(berries1ID, 0.0);
	  rmSetObjectDefCreateHerd(berries1ID, true);
      rmAddObjectDefConstraint(berries1ID, avoidFruits);
	  rmAddObjectDefConstraint(berries1ID, avoidWater10);
      rmPlaceObjectDefAtLoc(berries1ID, 0, 0.3, 0.35);
	  
	  int berries2ID=rmCreateObjectDef("The Berries 2");
      rmAddObjectDefItem(berries2ID, "BerryBush", rmRandInt(3,5), 5.0);
      rmSetObjectDefMinDistance(berries2ID, 0.0);
      rmSetObjectDefMaxDistance(berries2ID, 0.0);
	  rmSetObjectDefCreateHerd(berries2ID, true);
      rmAddObjectDefConstraint(berries2ID, avoidFruits);
	  rmAddObjectDefConstraint(berries2ID, avoidWater10);
      rmPlaceObjectDefAtLoc(berries2ID, 0, 0.3, 0.65);
	  
	  int berries3ID=rmCreateObjectDef("The Berries 3");
      rmAddObjectDefItem(berries3ID, "BerryBush", rmRandInt(3,5), 5.0);
      rmSetObjectDefMinDistance(berries3ID, 0.0);
      rmSetObjectDefMaxDistance(berries3ID, 0.0);
	  rmSetObjectDefCreateHerd(berries3ID, true);
      rmAddObjectDefConstraint(berries3ID, avoidFruits);
	  rmAddObjectDefConstraint(berries3ID, avoidWater10);
      rmPlaceObjectDefAtLoc(berries3ID, 0, 0.7, 0.35);
	  
	  int berries4ID=rmCreateObjectDef("The Berries 4");
      rmAddObjectDefItem(berries4ID, "BerryBush", rmRandInt(3,5), 5.0);
      rmSetObjectDefMinDistance(berries4ID, 0.0);
      rmSetObjectDefMaxDistance(berries4ID, 0.0);
	  rmSetObjectDefCreateHerd(berries4ID, true);
      rmAddObjectDefConstraint(berries4ID, avoidFruits);
	  rmAddObjectDefConstraint(berries4ID, avoidWater10);
      rmPlaceObjectDefAtLoc(berries4ID, 0, 0.7, 0.65);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE PONDS O' FUN: ************************************** //
/*================================================================================================================*/
	  if ( whichMap == 1 )
{
	  //int pondClass=rmDefineClass("pond");
      //int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 15.0);
     // int avoidPond=rmCreateClassDistanceConstraint("stuffs avoid ponds", rmClassID("pond"), 15.0);
	  
      // int numPonds=rmRandInt(1,4); // REMOVED BY ENSEMBLE:
	  //int numPonds=4; // REMOVED BY ME:

      int numPonds=1;
      for(i=0; <numPonds)
   {
      int smallPondID=rmCreateArea("small pond"+i);
      //rmSetAreaSize(smallPondID, rmAreaTilesToFraction(170), rmAreaTilesToFraction(200));
	  rmSetAreaSize(smallPondID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
      rmSetAreaWaterType(smallPondID, "great plains pond");
      rmSetAreaBaseHeight(smallPondID, 4);
      /*rmSetAreaMinBlobs(smallPondID, 1);
      rmSetAreaMaxBlobs(smallPondID, 5);
      rmSetAreaMinBlobDistance(smallPondID, 5.0);
      rmSetAreaMaxBlobDistance(smallPondID, 70.0);*/
	  rmSetAreaMinBlobs(smallPondID, 1);
      rmSetAreaMaxBlobs(smallPondID, 1);
      rmSetAreaMinBlobDistance(smallPondID, 1.0);
      rmSetAreaMaxBlobDistance(smallPondID, 1.0);
      rmAddAreaToClass(smallPondID, pondClass);
      rmSetAreaCoherence(smallPondID, 0.5);
      rmSetAreaSmoothDistance(smallPondID, 5);
      rmAddAreaConstraint(smallPondID, pondConstraint);
	  //rmAddAreaConstraint(smallPondID, avoidPond);
      //rmAddAreaConstraint(smallPondID, playerConstraint);
      //rmAddAreaConstraint(smallPondID, avoidTradeRoute);
	  //rmAddAreaConstraint(smallPondID, avoidSocket);
	  //rmAddAreaConstraint(smallPondID, avoidBison);
	  //rmAddAreaConstraint(smallPondID, avoidPronghorn);
	  //rmAddAreaConstraint(smallPondID, avoidImportantItem);
	  //rmAddAreaConstraint(smallPondID, avoidNatives);
	  //rmAddAreaConstraint(smallPondID, avoidFastCoin);
	  //rmAddAreaConstraint(smallPondID, avoidAll);
	  //rmAddAreaConstraint(smallPondID, avoidStartingUnits);
	  //rmAddAreaConstraint(smallPondID, avoidNuggetSmall);
      rmSetAreaWarnFailure(smallPondID, false);
	  rmSetAreaLocation(smallPondID, 0.50, 0.50);
      rmBuildArea(smallPondID);
   }
      
      for(i=0; <numPonds)
   {
      int smallPond2ID=rmCreateArea("small pond 2"+i);
      //rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(170), rmAreaTilesToFraction(200));
	  rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));
      rmSetAreaWaterType(smallPond2ID, "great plains pond");
      /*rmSetAreaBaseHeight(smallPond2ID, 4);
      rmSetAreaMinBlobs(smallPond2ID, 1);
      rmSetAreaMaxBlobs(smallPond2ID, 5);
      rmSetAreaMinBlobDistance(smallPond2ID, 5.0);
      rmSetAreaMaxBlobDistance(smallPond2ID, 70.0);*/
	  rmSetAreaMinBlobs(smallPond2ID, 1);
      rmSetAreaMaxBlobs(smallPond2ID, 1);
      rmSetAreaMinBlobDistance(smallPond2ID, 1.0);
      rmSetAreaMaxBlobDistance(smallPond2ID, 1.0);
      rmAddAreaToClass(smallPond2ID, pondClass);
      rmSetAreaCoherence(smallPond2ID, 0.5);
      rmSetAreaSmoothDistance(smallPond2ID, 5);
      rmAddAreaConstraint(smallPond2ID, pondConstraint);
	  //rmAddAreaConstraint(smallPond2ID, avoidPond);
      //rmAddAreaConstraint(smallPond2ID, playerConstraint);
      //rmAddAreaConstraint(smallPond2ID, avoidTradeRoute);
	  //rmAddAreaConstraint(smallPond2ID, avoidSocket);
	  //rmAddAreaConstraint(smallPond2ID, avoidBison);
	  //rmAddAreaConstraint(smallPond2ID, avoidPronghorn);
	  //rmAddAreaConstraint(smallPond2ID, avoidImportantItem);
	  //rmAddAreaConstraint(smallPond2ID, avoidFastCoin);
	  //rmAddAreaConstraint(smallPond2ID, avoidNW);
	  //rmAddAreaConstraint(smallPond2ID, avoidAll);
	  //rmAddAreaConstraint(smallPond2ID, avoidStartingUnits);
	  //rmAddAreaConstraint(smallPond2ID, avoidNuggetSmall);
      rmSetAreaWarnFailure(smallPond2ID, false);
	  rmSetAreaLocation(smallPond2ID, 0.50, 0.80);
      rmBuildArea(smallPond2ID);
   }
   

      for(i=0; <numPonds)
   {
      int smallPond3ID=rmCreateArea("small pond 3"+i);
      //rmSetAreaSize(smallPond3ID, rmAreaTilesToFraction(170), rmAreaTilesToFraction(200));
	  rmSetAreaSize(smallPond3ID, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));
      rmSetAreaWaterType(smallPond3ID, "great plains pond");
      rmSetAreaBaseHeight(smallPond3ID, 4);
      /*rmSetAreaMinBlobs(smallPond3ID, 1);
      rmSetAreaMaxBlobs(smallPond3ID, 5);
      rmSetAreaMinBlobDistance(smallPond3ID, 5.0);
      rmSetAreaMaxBlobDistance(smallPond3ID, 70.0);*/
	  rmSetAreaMinBlobs(smallPond3ID, 1);
      rmSetAreaMaxBlobs(smallPond3ID, 1);
      rmSetAreaMinBlobDistance(smallPond3ID, 1.0);
      rmSetAreaMaxBlobDistance(smallPond3ID, 1.0);
      rmAddAreaToClass(smallPond3ID, pondClass);
      rmSetAreaCoherence(smallPond3ID, 0.5);
      rmSetAreaSmoothDistance(smallPond3ID, 5);
      rmAddAreaConstraint(smallPond3ID, pondConstraint);
	  //rmAddAreaConstraint(smallPond3ID, avoidPond);
      //rmAddAreaConstraint(smallPond3ID, playerConstraint);
      //rmAddAreaConstraint(smallPond3ID, avoidTradeRoute);
	  //rmAddAreaConstraint(smallPond3ID, avoidSocket);
	  //rmAddAreaConstraint(smallPond3ID, avoidBison);
	  //rmAddAreaConstraint(smallPond3ID, avoidPronghorn);
	  //rmAddAreaConstraint(smallPond3ID, avoidImportantItem);
	  //rmAddAreaConstraint(smallPond3ID, avoidFastCoin);
	  //rmAddAreaConstraint(smallPond3ID, avoidAll);
	  //rmAddAreaConstraint(smallPond3ID, avoidStartingUnits);
	  //rmAddAreaConstraint(smallPond3ID, avoidNuggetSmall);
      rmSetAreaWarnFailure(smallPond3ID, false);
	  rmSetAreaLocation(smallPond3ID, 0.50, 0.20);
      rmBuildArea(smallPond3ID);
   }
   
} 
/*----------------------------------------------------------------------------------------------------------------*/
	    else if ( whichMap == 2 )
{
        rmClearClosestPointConstraints();
		
		int canyonClass=rmDefineClass("canyon");
        int canyonConstraint=rmCreateClassDistanceConstraint("canyons avoids canyons", rmClassID("canyon"), 15.0);
        int avoidCanyon=rmCreateClassDistanceConstraint("stuffs avoid canyon", rmClassID("canyon"), 15.0);
		
		int smallCliffHeight=rmRandInt(0,10);
		int smallMesaID=rmCreateArea("small mesa"+i);
		rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(1100), rmAreaTilesToFraction(1100)); 
		rmSetAreaWarnFailure(smallMesaID, false);
		rmSetAreaCliffType(smallMesaID, "Texas Grass");
		rmAddAreaToClass(smallMesaID, rmClassID("canyon"));	
		//rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(smallMesaID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesaID, -8, 1.0, 1.0);  
		rmSetAreaCoherence(smallMesaID, 0.88);
		rmSetAreaLocation(smallMesaID, 0.50, 0.50); 
		rmBuildArea(smallMesaID);
	

	// Special AREA CONSTRAINT and use it to make resources avoid the big mtn in center:
		//int smallMesaConstraint = rmCreateAreaDistanceConstraint("avoid Small Mesa", smallMesaID, 4.0);
				
		int smallCliff2Height=rmRandInt(0,10);
		int smallMesa2ID=rmCreateArea("small mesa 2"+i);
		rmSetAreaSize(smallMesa2ID, rmAreaTilesToFraction(1100), rmAreaTilesToFraction(1100)); 
		rmSetAreaWarnFailure(smallMesa2ID, false);
		rmSetAreaCliffType(smallMesa2ID, "Texas Grass");
		rmAddAreaToClass(smallMesa2ID, rmClassID("canyon"));	
		//rmSetAreaCliffEdge(smallMesa2ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(smallMesa2ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa2ID, -8, 1.0, 1.0);  
		rmSetAreaCoherence(smallMesa2ID, 0.88);
		rmSetAreaLocation(smallMesa2ID, 0.50, 0.20); 
		rmBuildArea(smallMesa2ID);
		
		int smallCliff3Height=rmRandInt(0,10);
		int smallMesa3ID=rmCreateArea("small mesa 3"+i);
		rmSetAreaSize(smallMesa3ID, rmAreaTilesToFraction(1100), rmAreaTilesToFraction(1100)); 
		rmSetAreaWarnFailure(smallMesa3ID, false);
		rmSetAreaCliffType(smallMesa3ID, "Texas Grass");
		rmAddAreaToClass(smallMesa3ID, rmClassID("canyon"));	
		//rmSetAreaCliffEdge(smallMesa3ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(smallMesa3ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa3ID, -8, 1.0, 1.0);  
		rmSetAreaCoherence(smallMesa3ID, 0.88);
		rmSetAreaLocation(smallMesa3ID, 0.50, 0.80); 
		rmBuildArea(smallMesa3ID);
		
		int goldID=rmCreateObjectDef("gold mine");
        rmAddObjectDefItem(goldID, "minegold", 1, 0.0);
        rmSetObjectDefMinDistance(goldID, 0.0);
        rmSetObjectDefMaxDistance(goldID, 0.0);
        //rmAddObjectDefConstraint(goldID, avoidFastCoin);
	    rmPlaceObjectDefAtLoc(goldID, 0, 0.5, 0.5);
		rmPlaceObjectDefAtLoc(goldID, 0, 0.5, 0.2);
		rmPlaceObjectDefAtLoc(goldID, 0, 0.5, 0.8);

} 
/*----------------------------------------------------------------------------------------------------------------*/
else
{  
      rmClearClosestPointConstraints();

      // Build the main river which defines the map more-or-less.
	  int amazonRiver = rmRiverCreate(-1, "Amazon River", 5, 18, 10, 10);
	  if (cNumberNonGaiaPlayers >2)
		  amazonRiver = rmRiverCreate(-1, "Amazon River", 6, 30, 14, 17);
	  if (cNumberNonGaiaPlayers >4)
		  amazonRiver = rmRiverCreate(-1, "Amazon River", 6, 30, 16, 20);
	  if (cNumberNonGaiaPlayers >6)
		  amazonRiver = rmRiverCreate(-1, "Amazon River", 6, 30, 18, 22);
      //rmRiverSetConnections(amazonRiver, 0.0, 1.0, 1.0, 0.0);
        rmRiverSetConnections(amazonRiver, 0.5, 0.0, 0.5, 1.0);
      //rmRiverSetShallowRadius(amazonRiver, 10);
        rmRiverSetShallowRadius(amazonRiver, 10);
      //rmRiverAddShallow(amazonRiver, rmRandFloat(0.2, 0.2));
        rmRiverAddShallow(amazonRiver, rmRandFloat(0.5, 0.5));
      //rmRiverAddShallow(amazonRiver, rmRandFloat(0.8, 0.8));
        rmRiverSetBankNoiseParams(amazonRiver, 0.07, 2, 1.5, 20.0, 0.667, 2.0);
      rmRiverBuild(amazonRiver);
      //rmRiverReveal(amazonRiver, 2); 
} 
/*----------------------------------------------------------------------------------------------------------------*/   
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE RESOURCES: *************************************** //
/*================================================================================================================*/
// ************** DEFINE AND PLACE THE FAST COIN: - THREE EXTRA PER PLAYER BEYOND STARTING RESOURCES: *********** //
/*================================================================================================================*/
	    int silverID = -1;
	    int silverCount = (cNumberNonGaiaPlayers*3);
	    rmEchoInfo("silver count = "+silverCount);

	    for(i=0; < silverCount)
	{
		silverType = rmRandInt(1,10);
		silverID = rmCreateObjectDef("silver "+i);
		rmAddObjectDefItem(silverID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silverID, 0.0);
		rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(silverID, avoidFastCoin);
		rmAddObjectDefConstraint(silverID, avoidAll);
		rmAddObjectDefConstraint(silverID, avoidCanyon);
		rmAddObjectDefConstraint(silverID, avoidNatives);
		rmAddObjectDefConstraint(silverID, avoidWater10);
		rmAddObjectDefConstraint(silverID, avoidPond);
		rmAddObjectDefConstraint(silverID, avoidImpassableLand);
		rmAddObjectDefConstraint(silverID, avoidFruits);
		//rmAddObjectDefConstraint(silverID, avoidSocket);
		rmAddObjectDefConstraint(silverID, coinForestConstraint);
		rmAddObjectDefConstraint(silverID, avoidStartingUnits);
		//rmAddObjectDefConstraint(silverID, smallMesaConstraint);
		int result = rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
		if(result == 0)
			break;
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE BISON: ***************************************** //	
/*================================================================================================================*/
      int bisonID=rmCreateObjectDef("bison herd");
      rmAddObjectDefItem(bisonID, "Bison", rmRandInt(12,16), 12.0);
      rmSetObjectDefMinDistance(bisonID, 0.0);
      rmSetObjectDefMaxDistance(bisonID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(bisonID, avoidBison);
	  rmAddObjectDefConstraint(bisonID, bisonAvoidBison);
	  rmAddObjectDefConstraint(bisonID, avoidCow);
	  rmAddObjectDefConstraint(bisonID, avoidAll);
	  rmAddObjectDefConstraint(bisonID, avoidNatives);
	  rmAddObjectDefConstraint(bisonID, avoidWater10);
	  rmAddObjectDefConstraint(bisonID, avoidPond);
	  rmAddObjectDefConstraint(bisonID, avoidCanyon);
      rmAddObjectDefConstraint(bisonID, avoidImpassableLand);
	  rmAddObjectDefConstraint(bisonID, avoidFruits);
	  rmAddObjectDefConstraint(bisonID, avoidStartingUnits);
	  rmSetObjectDefCreateHerd(bisonID, true);
	  rmPlaceObjectDefAtLoc(bisonID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE PRONGHORN: **************************************** //	
/*================================================================================================================*/
      int pronghornID=rmCreateObjectDef("pronghorn herd");
      rmAddObjectDefItem(pronghornID, "pronghorn", rmRandInt(6,9), 10.0);
      rmSetObjectDefMinDistance(pronghornID, 0.0);
      rmSetObjectDefMaxDistance(pronghornID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(pronghornID, avoidBison);
	  rmAddObjectDefConstraint(pronghornID, avoidCow);
      rmAddObjectDefConstraint(pronghornID, avoidPronghorn);
	  rmAddObjectDefConstraint(pronghornID, avoidAll);
	  rmAddObjectDefConstraint(pronghornID, avoidCanyon);
	  rmAddObjectDefConstraint(pronghornID, avoidNatives);
	  rmAddObjectDefConstraint(pronghornID, avoidWater10);
	  rmAddObjectDefConstraint(pronghornID, avoidPond);
      rmAddObjectDefConstraint(pronghornID, avoidImpassableLand);
	  rmAddObjectDefConstraint(pronghornID, avoidFruits);
	  //rmAddObjectDefConstraint(pronghornID, avoidSocket);
	  rmAddObjectDefConstraint(pronghornID, avoidStartingUnits);
	  //rmAddObjectDefConstraint(pronghornID, smallMesaConstraint);
      rmSetObjectDefCreateHerd(pronghornID, true);
	  rmPlaceObjectDefAtLoc(pronghornID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE COWS: ****************************************** //	
/*================================================================================================================*/
      int cow1ID=rmCreateObjectDef("The Cows 1");
      rmAddObjectDefItem(cow1ID, "cow", rmRandInt(4,6), 6.0);
      rmSetObjectDefMinDistance(cow1ID, 0.0);
      rmSetObjectDefMaxDistance(cow1ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(cow1ID, avoidCow);
	  rmAddObjectDefConstraint(cow1ID, cowAvoidCow);
	  rmAddObjectDefConstraint(cow1ID, avoidBison);
      rmAddObjectDefConstraint(cow1ID, avoidPronghorn);
	  rmAddObjectDefConstraint(cow1ID, avoidAll);
	  rmAddObjectDefConstraint(cow1ID, avoidCanyon);
	  rmAddObjectDefConstraint(cow1ID, avoidNatives);
	  rmAddObjectDefConstraint(cow1ID, avoidWater10);
	  rmAddObjectDefConstraint(cow1ID, avoidPond);
      rmAddObjectDefConstraint(cow1ID, avoidImpassableLand);
	  rmAddObjectDefConstraint(cow1ID, avoidFruits);
	  rmAddObjectDefConstraint(cow1ID, avoidStartingUnits);
	  //rmSetObjectDefCreateHerd(cow1ID, true);
	  rmPlaceObjectDefAtLoc(cow1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);	  
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //
/*================================================================================================================*/
	  int nuggetID= rmCreateObjectDef("nugget"); 
	  rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nuggetID, 0.0);
	  rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(nuggetID, shortAvoidImpassableLand);
  	  rmAddObjectDefConstraint(nuggetID, avoidNugget);
	  rmAddObjectDefConstraint(nuggetID, nuggetAvoidNugget);
	  rmAddObjectDefConstraint(nuggetID, nuggetPlayerConstraint);
  	  rmAddObjectDefConstraint(nuggetID, playerConstraint);
  	  rmAddObjectDefConstraint(nuggetID, avoidNativesNuggets);
	  rmAddObjectDefConstraint(nuggetID, circleConstraint);
  	  rmAddObjectDefConstraint(nuggetID, avoidAll);
	  rmAddObjectDefConstraint(nuggetID, avoidCanyon);
	  rmAddObjectDefConstraint(nuggetID, avoidWater10);
	  rmAddObjectDefConstraint(nuggetID, avoidFastCoin);
	  rmAddObjectDefConstraint(nuggetID, avoidPronghorn);
	  rmAddObjectDefConstraint(nuggetID, avoidBison);
	  rmAddObjectDefConstraint(nuggetID, avoidCow);
	  rmAddObjectDefConstraint(nuggetID, avoidFruits);
	  rmAddObjectDefConstraint(nuggetID, avoidPond);
	  rmSetNuggetDifficulty(1, 3);
	  rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
/*================================================================================================================*/	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE FORESTS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        rmClearClosestPointConstraints();

        int forestTreeID = 0;
        int numTries=6*cNumberNonGaiaPlayers;
        int failCount=0;
        for (i=0; <numTries)
   {   
		int forest=rmCreateArea("center forest "+i);
		rmSetAreaWarnFailure(forest, false);
		rmSetAreaSize(forest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
		rmSetAreaForestType(forest, "great plains forest");
		rmSetAreaForestDensity(forest, 0.9);
		rmSetAreaForestClumpiness(forest, 0.8);
		rmSetAreaForestUnderbrush(forest, 0.0);
		rmSetAreaCoherence(forest, 0.5);
		// rmSetAreaSmoothDistance(forest, 10);
		rmAddAreaToClass(forest, rmClassID("classForest")); 
		// rmAddAreaConstraint(forest, lowForestConstraint);
		rmAddAreaConstraint(forest, forestConstraint);
		rmAddAreaConstraint(forest, playerConstraint);
		rmAddAreaConstraint(forest, avoidImportantItem);
		rmAddAreaConstraint(forest, avoidImpassableLand); 
		//rmAddAreaConstraint(forest, avoidTradeRoute);
		rmAddAreaConstraint(forest, avoidCow);
		rmAddAreaConstraint(forest, avoidCanyon);
		rmAddAreaConstraint(forest, avoidWater10);
		rmAddAreaConstraint(forest, avoidFruits);
		rmAddAreaConstraint(forest, avoidClosePond);
		rmAddAreaConstraint(forest, avoidCloseNatives);
		rmAddAreaConstraint(forest, avoidNuggetSmall);
		// rmAddAreaConstraint(forest, avoidFastCoin);
		rmAddAreaConstraint(forest, avoidStartingUnits);
		if(rmBuildArea(forest)==false)
		{
			// Stop trying once we fail 10 times in a row.
			failCount++;
			if(failCount==10)
			break;
		}
		else
			failCount=0; 
   }
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE RANDOM TREES: ************************************** //
/*================================================================================================================*/
      int treeID= rmCreateObjectDef("Random Trees"); 
	  rmAddObjectDefItem(treeID, "TreeGreatPlains", 1, 0.0);
	  rmSetObjectDefMinDistance(treeID, 0.0);
	  rmSetObjectDefMaxDistance(treeID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(treeID, shortAvoidImpassableLand);
  	  rmAddObjectDefConstraint(treeID, avoidNugget);
	  rmAddObjectDefConstraint(treeID, avoidClosePond);
	  rmAddObjectDefConstraint(treeID, nuggetPlayerConstraint);
  	  rmAddObjectDefConstraint(treeID, playerConstraint);
  	  //rmAddObjectDefConstraint(treeID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(treeID, avoidSocketMore);
	  rmAddObjectDefConstraint(treeID, avoidNativesNuggets);
	  //rmAddObjectDefConstraint(treeID, circleConstraint);
  	  rmAddObjectDefConstraint(treeID, avoidAll);
	  rmAddObjectDefConstraint(treeID, avoidFruits);
	  rmAddObjectDefConstraint(treeID, avoidCanyon);
	  rmAddObjectDefConstraint(treeID, avoidWater10);
	  rmAddObjectDefConstraint(treeID, avoidCloseNatives);
	  //rmAddObjectDefConstraint(treeID, smallMesaConstraint);
	  rmAddObjectDefConstraint(treeID, avoidArbuste);
	  rmPlaceObjectDefAtLoc(treeID, 0, 0.5, 0.5, 50); 
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE FISHES: ****************************************** //
/*================================================================================================================*/
      int fishID=rmCreateObjectDef("fish");
      rmAddObjectDefItem(fishID, "FishBass", 3, 9.0);
      rmSetObjectDefMinDistance(fishID, 0.0);
      rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(fishID, fishVsFishID);
      rmAddObjectDefConstraint(fishID, fishLand);
      rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 15);	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
// **************************************** THIS IS THE END OF THE MAP: ***************************************** //
/*================================================================================================================*/
} 
/*================================================================================================================*/
 